use crate::{schema, UIDCError};
use microrm::cli::CLIObject;

#[derive(clap::Parser, Debug)]
pub struct CreateParameters {
    shortname: String,
}

impl CLIObject for schema::Role {
    type Error = UIDCError;
    type CreateParameters = CreateParameters;

    fn create_from_params(cp: &Self::CreateParameters) -> Result<Self, UIDCError> {
        Ok(Self {
            shortname: cp.shortname.clone(),
            groups: Default::default(),
        })
    }

    type ExtraCommands = microrm::cli::EmptyCommand;
    type ExtraCommandData = schema::Realm;

    fn shortname(&self) -> &str {
        &self.shortname
    }
}
